# Ignite API types

The Ignite API types use the `k8s.io/apimachinery` framework, and
similar conventions as the Kubernetes API types. That said, the Ignite API types don't (at the moment at least)
have any connection or depend on Kubernetes itself in any way.

The API types are used for two primary things:

* Letting end users [declaratively specify advanced configuration](../declarative-config.md) (e.g. `ignite create --config`)
* Persisting internal data on disk in a standardized way.

Please refer to the (autogenerated) docs for the API types below:

- [ignite/v1alpha1](ignite_v1alpha1.md)
- [ignite/v1alpha2](ignite_v1alpha2.md)
- [ignite/v1alpha3](ignite_v1alpha3.md)
- [ignite/v1alpha4](ignite_v1alpha4.md)
- [meta/v1alpha1](meta_v1alpha1.md)
