## v0.9.0

**Released:** 4/12/2021

This release allows changing the internal id prefixes of VM components. This overcomes limitations /w CNI's like Weave net.
A U/X improvement has been made to the VM list command to show when the container runtime state of the VM does not match what
ignite has stored in the API objet.

New base OS images and kernels have been released with the GitHub Actions release tools.
A [`k3s`](https://k3s.io/) OS image is now pushed for amd64.
The default kernel has been updated to `5.4.108`.

This release consists of **37** noteworthy PR's from **6** contributors.  **11** of these patches were sent by **3** external contributors.
**11** patches were sent by **3** people new to the project; welcome! :)
Thanks so much for using and contributing back to the project.


Cheers to everyone who was part of shipping this release:
- @bboreham
- @darkowlzz
- @EmeraldShift
- @gaby
- @onatm
- @stealthybox


## Installing

Check out the guide here: https://ignite.rtfd.io/en/stable/installation/


## OCI Images for this release

[ignite](
https://hub.docker.com/r/weaveworks/ignite/tags?page=1&name=v0.9.0
) ( sandbox )  

[ignite-kernel:4.14.227](
https://hub.docker.com/r/weaveworks/ignite-kernel/tags?page=1&name=4.14.227
) [multi-arch]
[ignite-kernel:4.19.183](
https://hub.docker.com/r/weaveworks/ignite-kernel/tags?page=1&name=4.19.183
) [multi-arch]
[ignite-kernel:5.4.108](
https://hub.docker.com/r/weaveworks/ignite-kernel/tags?page=1&name=5.4.108
) [multi-arch] ( default )
[ignite-kernel:5.10.25](
https://hub.docker.com/r/weaveworks/ignite-kernel/tags?page=1&name=5.10.25
) [multi-arch]


[ignite-amazon-kernel](
https://hub.docker.com/r/weaveworks/ignite-amazon-kernel/tags?page=1&name=v0.9.0
)  
[ignite-amazonlinux](
https://hub.docker.com/r/weaveworks/ignite-amazonlinux/tags?page=1&name=v0.9.0
) 2  
[ignite-alpine](
https://hub.docker.com/r/weaveworks/ignite-alpine/tags?page=1&name=v0.9.0
)  
[ignite-centos](
https://hub.docker.com/r/weaveworks/ignite-centos/tags?page=1&name=v0.9.0
) 7, 8  
[ignite-opensuse](
https://hub.docker.com/r/weaveworks/ignite-opensuse/tags?page=1&name=v0.9.0
) tumbleweed, leap  
[ignite-ubuntu](
https://hub.docker.com/r/weaveworks/ignite-ubuntu/tags?page=1&name=v0.9.0
) [multi-arch] 16.04, 18.04, 20.04  
[ignite-kubeadm](
https://hub.docker.com/r/weaveworks/ignite-kubeadm/tags?page=1&name=v0.9.0
) [multi-arch] v1.18.3  
[ignite-k3s](
https://hub.docker.com/r/weaveworks/ignite-kubeadm/tags?page=1&name=v0.9.0
) v1.20.4  


_________________


## Enhancements

- Add option to change ID prefix ([#757](https://github.com/weaveworks/ignite/pull/757), [bboreham](https://github.com/bboreham), [stealthybox](https://github.com/stealthybox))
- ps: Mark VM with * when the state can't be confirmed ([#808](https://github.com/weaveworks/ignite/pull/808), [darkowlzz](https://github.com/darkowlzz))
- ps: Add out-of-date VM manifest status indicator ([#787](https://github.com/weaveworks/ignite/pull/787), [darkowlzz](https://github.com/darkowlzz))
   

## Runtime

- Change the log level in RemoveContainer to debug ([#812](https://github.com/weaveworks/ignite/pull/812), [darkowlzz](https://github.com/darkowlzz))
- runtime: Get containerd container task status ([#779](https://github.com/weaveworks/ignite/pull/779), [darkowlzz](https://github.com/darkowlzz))
- Fix containerd cont delete when task load or delete fails ([#791](https://github.com/weaveworks/ignite/pull/791), [stealthybox](https://github.com/stealthybox))
- Avoid race between stop/kill and wait ([#773](https://github.com/weaveworks/ignite/pull/773), [bboreham](https://github.com/bboreham))
  

## Bug Fixes

- runtime: Handle error when container not found ([#809](https://github.com/weaveworks/ignite/pull/809), [darkowlzz](https://github.com/darkowlzz))
- Handle error when the backend storage is uninitialized ([#807](https://github.com/weaveworks/ignite/pull/807), [darkowlzz](https://github.com/darkowlzz))
- ps: Handle error when the backend storage is uninitialized ([#778](https://github.com/weaveworks/ignite/pull/778), [darkowlzz](https://github.com/darkowlzz))
- Use declarative port mappings and copy files values when CLI flags are empty ([#796](https://github.com/weaveworks/ignite/pull/796), [onatm](https://github.com/onatm))
- Fix vm stop-start with default providers ([#735](https://github.com/weaveworks/ignite/pull/735), [darkowlzz](https://github.com/darkowlzz))
- Avoid crash when network has no gateway ([#749](https://github.com/weaveworks/ignite/pull/749), [bboreham](https://github.com/bboreham))
- Refactor: extract TarExtract function ([#762](https://github.com/weaveworks/ignite/pull/762), [bboreham](https://github.com/bboreham))


## Docs

- Fix MASTER_IP definition in kubeadm README ([#741](https://github.com/weaveworks/ignite/pull/741), [EmeraldShift](https://github.com/EmeraldShift))
  

## OS Images

- Bump k3s to v1.20.4+k3s1 ([#800](https://github.com/weaveworks/ignite/pull/800), [gaby](https://github.com/gaby))
- Bump ignite-spawn base image to Alpine to 3.13 ([#799](https://github.com/weaveworks/ignite/pull/799), [gaby](https://github.com/gaby))
- Add a k3s sample image ([#739](https://github.com/weaveworks/ignite/pull/739), [EmeraldShift](https://github.com/EmeraldShift))
    

## Kernels

- Support for Linux LTS kernel 5.10.x ([#804](https://github.com/weaveworks/ignite/pull/804), [gaby](https://github.com/gaby))
- Upgrade kernel versions ([#798](https://github.com/weaveworks/ignite/pull/798), [gaby](https://github.com/gaby))
- Bump default kernel to 5.4.102 ([#806](https://github.com/weaveworks/ignite/pull/806), [gaby](https://github.com/gaby))
- Bump Kernel versions. Bump default kernel version to 5.4.108 ([#811](https://github.com/weaveworks/ignite/pull/811), [gaby](https://github.com/gaby))
- Bump Kernel Versions for #811 ([#815](https://github.com/weaveworks/ignite/pull/815), [stealthybox](https://github.com/stealthybox))


## Dependencies

- Upgrade to Firecracker v0.22.0 ([#692](https://github.com/weaveworks/ignite/pull/692), [stealthybox](https://github.com/stealthybox))
- Upgrade firecracker to v0.22.4 ([#797](https://github.com/weaveworks/ignite/pull/797), [gaby](https://github.com/gaby))
- Bump CNI to v0.8.7 ([#731](https://github.com/weaveworks/ignite/pull/731), [stealthybox](https://github.com/stealthybox))
- Bump CNI Plugins to 0.9.1 ([#805](https://github.com/weaveworks/ignite/pull/805), [gaby](https://github.com/gaby))


## Build

- Cache versioned shallow clones for kernel config patching ([#814](https://github.com/weaveworks/ignite/pull/814), [stealthybox](https://github.com/stealthybox))
- Fix #! to use /usr/bin/env for certain scripts ([#789](https://github.com/weaveworks/ignite/pull/789), [stealthybox](https://github.com/stealthybox))


## Testing

- Small test improvements ([#760](https://github.com/weaveworks/ignite/pull/760), [bboreham](https://github.com/bboreham))
- Show output in test to aid debugging ([#759](https://github.com/weaveworks/ignite/pull/759), [bboreham](https://github.com/bboreham))
- Move from Travis to Semaphore CI ([#770](https://github.com/weaveworks/ignite/pull/770), [bboreham](https://github.com/bboreham))


## Releasing

- workflow/release-os-images: Disable fail-fast ([#730](https://github.com/weaveworks/ignite/pull/730), [darkowlzz](https://github.com/darkowlzz))
- Allow clean builds from tarballs ([#766](https://github.com/weaveworks/ignite/pull/766), [stealthybox](https://github.com/stealthybox))
- Add k3s to the release-os-image gh workflow ([#802](https://github.com/weaveworks/ignite/pull/802), [darkowlzz](https://github.com/darkowlzz))
- is_git_repo: Return without echo ([#801](https://github.com/weaveworks/ignite/pull/801), [darkowlzz](https://github.com/darkowlzz))
- Fix small bug in hack/gen-release-notes.sh ([#817](https://github.com/weaveworks/ignite/pull/817), [stealthybox](https://github.com/stealthybox))


## Automated

- Bump peter-evans/create-pull-request from v3.8.1 to v3.8.2 ([#781](https://github.com/weaveworks/ignite/pull/781), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.7.0 to v3.8.1 ([#780](https://github.com/weaveworks/ignite/pull/780), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.6.0 to v3.7.0 ([#774](https://github.com/weaveworks/ignite/pull/774), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.5.2 to v3.6.0 ([#758](https://github.com/weaveworks/ignite/pull/758), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.5.1 to v3.5.2 ([#743](https://github.com/weaveworks/ignite/pull/743), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.5.0 to v3.5.1 ([#738](https://github.com/weaveworks/ignite/pull/738), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump peter-evans/create-pull-request from v3.4.1 to v3.5.0 ([#732](https://github.com/weaveworks/ignite/pull/732), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump golangci/golangci-lint-action from v2.5.1 to v2.5.2 ([#816](https://github.com/weaveworks/ignite/pull/816), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump golangci/golangci-lint-action from v2.3.0 to v2.5.1 ([#786](https://github.com/weaveworks/ignite/pull/786), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump actions/setup-python from v2.2.0 to v2.2.1 ([#753](https://github.com/weaveworks/ignite/pull/753), [dependabot[bot]](https://github.com/dependabot[bot]))
- Bump actions/setup-python from v2.1.4 to v2.2.0 ([#752](https://github.com/weaveworks/ignite/pull/752), [dependabot[bot]](https://github.com/dependabot[bot]))
- [automated] Update go dependencies ([#767](https://github.com/weaveworks/ignite/pull/767), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#747](https://github.com/weaveworks/ignite/pull/747), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#742](https://github.com/weaveworks/ignite/pull/742), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#737](https://github.com/weaveworks/ignite/pull/737), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#733](https://github.com/weaveworks/ignite/pull/733), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#729](https://github.com/weaveworks/ignite/pull/729), [github-actions[bot]](https://github.com/github-actions[bot]))
- [automated] Update go dependencies ([#769](https://github.com/weaveworks/ignite/pull/769), [github-actions[bot]](https://github.com/github-actions[bot]))
